;=========================================================
;DirectDraw structures/values (many thanks to FASM example files)
;=========================================================

interface DirectDraw,\
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    Compact,\
	    CreateClipper,\
	    CreatePalette,\
	    CreateSurface,\
	    DuplicateSurface,\
	    EnumDisplayModes,\
	    EnumSurfaces,\
	    FlipToGDISurface,\
	    GetCaps,\
	    GetDisplayMode,\
	    GetFourCCCodes,\
	    GetGDISurface,\
	    GetMonitorFrequency,\
	    GetScanLine,\
	    GetVerticalBlankStatus,\
	    Initialize,\
	    RestoreDisplayMode,\
	    SetCooperativeLevel,\
	    SetDisplayMode,\
	    WaitForVerticalBlank,\
	    GetAvailableVidMem,\
	    GetSurfaceFromDC,\
	    RestoreAllSurfaces,\
	    TestCooperativeLevel,\
	    GetDeviceIdentifier,\
	    StartModeTest,\
	    EvaluateMode

interface DirectDrawSurface,\
	    QueryInterface,\
	    AddRef,\
	    Release,\
	    AddAttachedSurface,\
	    AddOverlayDirtyRect,\
	    Blt,\
	    BltBatch,\
	    BltFast,\
	    DeleteAttachedSurface,\
	    EnumAttachedSurfaces,\
	    EnumOverlayZOrders,\
	    Flip,\
	    GetAttachedSurface,\
	    GetBltStatus,\
	    GetCaps,\
	    GetClipper,\
	    GetColorKey,\
	    GetDC,\
	    GetFlipStatus,\
	    GetOverlayPosition,\
	    GetPalette,\
	    GetPixelFormat,\
	    GetSurfaceDesc,\
	    Initialize,\
	    IsLost,\
	    Lock,\
	    ReleaseDC,\
	    Restore,\
	    SetClipper,\
	    SetColorKey,\
	    SetOverlayPosition,\
	    SetPalette,\
	    Unlock,\
	    UpdateOverlay,\
	    UpdateOverlayDisplay,\
	    UpdateOverlayZOrder,\
	    GetDDInterface,\
	    PageLock,\
	    PageUnlock,\
	    SetSurfaceDesc,\
	    SetPrivateData,\
	    GetPrivateData,\
	    FreePrivateData,\
	    GetUniquenessValue,\
	    ChangeUniquenessValue,\
	    SetPriority,\
	    GetPriority,\
	    SetLOD,\
	    GetLOD

DDLOCK_SURFACEMEMORYPTR   =	000000000h
DDLOCK_WAIT		  =	000000001h
DDLOCK_EVENT		  =	000000002h
DDLOCK_READONLY 	  =	000000010h
DDLOCK_WRITEONLY	  =	000000020h
DDLOCK_NOSYSLOCK	  =	000000800h

DDERR_WASSTILLDRAWING		  =	088760000h+540
DDERR_SURFACELOST		  =	088760000h+450

struct DDCOLORKEY
  .dwColorSpaceLowValue  dd ?
  .dwColorSpaceHighValue dd ?
ends

struct DDPIXELFORMAT
	.dwSize 	   dd ?
	.dwFlags	   dd ?
	.dwFourCC	   dd ?
  label .dwYUVBitCount	   dword
  label .dwZBufferBitDepth dword
  label .dwAlphaBitDepth   dword
	.dwRGBBitCount	   dd ?
  label .dwYBitMask	   dword
	.dwRBitMask	   dd ?
  label .dwUBitMask	   dword
	.dwGBitMask	   dd ?
  label .dwVBitMask	   dword
	.dwBBitMask	   dd ?
  label .dwYUVAlphaBitMask dword
  label .dwRGBZBitMask	   dword
  label .dwYUVZBitMask	   dword
	.dwRGBAlphaBitMask dd ?
ends

struct DDSCAPS2
  .dwCaps  dd ?
  .dwCaps2 dd ?
  .dwCaps3 dd ?
  .dwCaps4 dd ?
ends

struct DDSURFACEDESC2
	.dwSize 	   dd ?
	.dwFlags	   dd ?
	.dwHeight	   dd ?
	.dwWidth	   dd ?
  label .dwLinearSize	   dword
	.lPitch 	   dd ?
	.dwBackBufferCount dd ?
  label .dwZBufferBitDepth dword
  label .dwRefreshRate	   dword
	.dwMipMapCount	   dd ?
	.dwAlphaBitDepth   dd ?
	.dwReserved	   dd ?
	.lpSurface	   dd ?
	.ddckCKDestOverlay DDCOLORKEY
	.ddckCKDestBlt	   DDCOLORKEY
	.ddckCKSrcOverlay  DDCOLORKEY
	.ddckCKSrcBlt	   DDCOLORKEY
	.ddpfPixelFormat   DDPIXELFORMAT
	.ddsCaps	   DDSCAPS2
	.dwTextureStage    dd ?
ends

DDBLT_ALPHADEST 		 =     000000001h
DDBLT_ALPHADESTCONSTOVERRIDE	 =     000000002h
DDBLT_ALPHADESTNEG		 =     000000004h
DDBLT_ALPHADESTSURFACEOVERRIDE	 =     000000008h
DDBLT_ALPHAEDGEBLEND		 =     000000010h
DDBLT_ALPHASRC			 =     000000020h
DDBLT_ALPHASRCCONSTOVERRIDE	 =     000000040h
DDBLT_ALPHASRCNEG		 =     000000080h
DDBLT_ALPHASRCSURFACEOVERRIDE	 =     000000100h
DDBLT_ASYNC			 =     000000200h
DDBLT_COLORFILL 		 =     000000400h
DDBLT_DDFX			 =     000000800h
DDBLT_DDROPS			 =     000001000h
DDBLT_KEYDEST			 =     000002000h
DDBLT_KEYDESTOVERRIDE		 =     000004000h
DDBLT_KEYSRC			 =     000008000h
DDBLT_KEYSRCOVERRIDE		 =     000010000h
DDBLT_ROP			 =     000020000h
DDBLT_ROTATIONANGLE		 =     000040000h
DDBLT_ZBUFFER			 =     000080000h
DDBLT_ZBUFFERDESTCONSTOVERRIDE	 =     000100000h
DDBLT_ZBUFFERDESTOVERRIDE	 =     000200000h
DDBLT_ZBUFFERSRCCONSTOVERRIDE	 =     000400000h
DDBLT_ZBUFFERSRCOVERRIDE	 =     000800000h
DDBLT_WAIT			 =     001000000h
DDBLT_DEPTHFILL 		 =     002000000h


struct DDBLTFX		      ;(not from example)
	.dwSize 		  dd	   DDBLTFX
	.dwDDFX 		  dd	   ?
	.dwROP			  dd	   ?
	.dwDDROP		  dd	   ?
	.dwRotationAngle	  dd	   ?
	.dwZBufferOpCode	  dd	   ?
	.dwZBufferLow		  dd	   ?
	.dwZBufferHigh		  dd	   ?
	.dwZBufferBaseDest	  dd	   ?
	.dwZDestConstBitDepth	  dd	   ?
  label .dwZDestConst		  dword
	.lpDDSZBufferDest	  dd	   ?
	.dwZSrcConstBitDepth	  dd	   ?
  label .dwZSrcConst		  dword
	.lpDDSZBufferSrc	  dd	   ?
	.dwAlphaEdgeBlendBitDepth dd	   ?
	.dwAlphaEdgeBlend	  dd	   ?
	.dwReserved		  dd	   ?
	.dwAlphaDestConstBitDepth dd	   ?
  label .dwAlphaDestConst	  dword
	.lpDDSAlphaDest 	  dd	   ?
	.dwAlphaSrcConstBitDepth  dd	   ?
  label .dwAlphaSrcConst	  dword
	.lpDDSAlphaSrc		  dd	   ?
  label .dwFillColor		  dword
  label .dwFillDepth		  dword
  label .dwFillPixel		  dword
	.lpDDSPattern		  dd	   ?
	.ddckDestColorkey	  DDCOLORKEY
	.ddckSrcColorkey	  DDCOLORKEY
ends




