;============================================================
;Checks current level file and compares to entries in INI file.
;============================================================
;CALLED BEFORE EVERY LEVEL START
;NEW: also includes CAnimal instance modification code
;Loads if same file name found.

;[ebp-4] = file handle
;[ebp-8] = file mapping handle (if used/not saved game)
;[ebp-12] = map view of file handle / address to INI file (if used)
;[ebp-16] = address of level name string (in EXE)
;ebx = EOF marker

LOADINITIALBITMAP:	;called after calls near "Finished Loading!" string
			;reference
push ebp
mov ebp,esp
sub esp,200
push ebx
push ecx
push edx
push esi
push edi
push eax

mov DWORD [ebp-4],0
mov DWORD [ebp-8],0
;================================================================
	mov esi,[LEVELNAME_OBJ] 	;(esi points to level SCN name)
	add esi,20			;(esi points to savegame/scn file name and path)
	mov edi,SAVEGAMENAME_BUFFER	;PATH+NAME OF CURRENT LEVEL FILE COPY (OR SAVEGAME)
	call TransferString

	call IsLevelSavedGame
	test eax,eax
	     jz STANDARD_SCN_FILE

;================================================================
;------------- assume it is otherwise a saved game
;================================================================
	mov DWORD [edi-8],'DMAP'	;possible save extension saved as 'SAVEDMAP.xxx'

invoke CreateFile,SAVEGAMENAME_BUFFER,GENERIC_READ,0,0,\
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	test eax,eax
	     jz SAVED_FILE_LOAD_FAIL
	cmp eax,-1
	    jz SAVED_FILE_LOAD_FAIL
	mov [ebp-4],eax

invoke GetFileSize,eax,0
	cmp eax,-1
	    jz SAVED_FILE_LOAD_FAIL
	cmp eax,21		;at least 4 32-bit floats + 'x.bmp'
	    jb SAVED_FILE_LOAD_FAIL

invoke SetFilePointer,DWORD [ebp-4],0,0,FILE_BEGIN
	cmp eax,-1
	    jz SAVED_FILE_LOAD_FAIL

	lea eax,[ebp-8] 	;read 4 POSITION float values and store
invoke ReadFile,DWORD [ebp-4],SAVED_MAP_X1,16,eax,0
	test eax,eax
	     jz SAVED_FILE_LOAD_FAIL
	cmp DWORD [ebp-8],16
	    jnz SAVED_FILE_LOAD_FAIL

	lea eax,[ebp-8] 	;read BITMAP name and store
invoke ReadFile,DWORD [ebp-4],SAVED_MAP_BUFFER,80,eax,0
	test eax,eax
	     jz SAVED_FILE_LOAD_FAIL

;================================================================
;----------------- LOAD BITMAP FROM SAVED INDEX
;================================================================

	mov ecx,SAVED_MAP_OBJECT
	call AT102MAIN
	test eax,eax		;if load fails, use level's originally indexed map
	     jnz End_LOADBMP_345345	  ;(jumps if success)

SAVED_FILE_LOAD_FAIL:
	;CLOSEHANDLE DWORD [ebp-4]

;================================================================
STANDARD_SCN_FILE:
;================================================================

	mov edi,MapsDirBuffer
	mov esi,MapIndex		 ;INI filename
	add edi,[MapsPathSize]
	call TransferString

;================================================================
;scan for bitmap name in/from level name section; if found, scan for X/Y position values
;================================================================
	mov esi,[LEVELNAME_OBJ]  ;addr of SCN level name string (section)

	lea edx,[ebp-200]
	mov [AT102EMULATEDOBJECT+8],edx
invoke GetPrivateProfileString,esi,STRING_Bitmap,STRING_BMPDEF,edx,192,MapsDirBuffer
	cmp DWORD [ebp-200],00464544h		;default string "DEF",0
	    jz NEW_BITMAP_LOAD_FAIL

invoke GetPrivateProfileFloat,esi,STRING_X1,STRING_ZERO,MapsDirBuffer
	mov [AT102EMULATEDOBJECT+12],eax
invoke GetPrivateProfileFloat,esi,STRING_Y1,STRING_ZERO,MapsDirBuffer
	mov [AT102EMULATEDOBJECT+16],eax
invoke GetPrivateProfileFloat,esi,STRING_X2,STRING_ZERO,MapsDirBuffer
	mov [AT102EMULATEDOBJECT+20],eax
invoke GetPrivateProfileFloat,esi,STRING_Y2,STRING_ZERO,MapsDirBuffer
	mov [AT102EMULATEDOBJECT+24],eax

;================================================================
;------ Load new bitmap (if not saved game)
;================================================================
	mov ecx,AT102EMULATEDOBJECT
	call AT102MAIN		;emulates a normal AT102 call to load file
	     test eax,eax
		  jnz End_LOADBMP_345345	;(jump if success)
;================================================================
NEW_BITMAP_LOAD_FAIL:
	LOCALRELEASE [currentbitmap]		;unload old map if existing
;================================================================
End_LOADBMP_345345:

;================================================================
	call Modify_External
;================================================================
	CLOSEHANDLE DWORD [ebp-4]
	mov ecx,[MapsPathSize]
	mov BYTE [ecx+MapsDirBuffer],0
pop eax
pop edi
pop esi
pop edx
pop ecx
pop ebx
mov esp,ebp
pop ebp

	  ;REPLACED CODE HERE
	  add esp,604h+4
	  jmp DWORD [esp-(604h+4)]
